unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Edit2: TEdit;
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
    procedure Edit1Exit(Sender: TObject);
    procedure Edit2KeyPress(Sender: TObject; var Key: Char);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
{------------------------------------}
{ N'autoriser que des nombres rels  }
{------------------------------------}

procedure TForm1.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  if not (key in [#8,'0'..'9',DecimalSeparator,'+','-']) then key:=#0;
end;

procedure TForm1.Edit1Exit(Sender: TObject);
// cette procdure se dclenche lorsque l'on tente de passer le focus  un autre composant
Var R:Real;
begin
  if Edit1.Text='' then Edit1.Text:='0';
  try
    R:=StrToFloat(Edit1.text); // on tente de convertir le texte en rel
  except // si cela ne marche pas, les lignes suivantes sont excutes
    ShowMessage('Nombre non valide');
    form1.ActiveControl:=Edit1; // on remet le focus sur Edit1
  end;
end;


///////////////////////////////////////////////////////////
{--------------------------------------------------------}
{Transformer en majuscule au fur et  mesure de la frappe}
{--------------------------------------------------------}

procedure TForm1.Edit2KeyPress(Sender: TObject; var Key: Char);
begin
  Key:=Upcase(Key);
end;

end.
